#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2007 - Kirill A. Korinskiy - catap@catap.ru
# Copyright (C) 2007 - Vadim Kalinnkov - bulvinkl@gmail.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it would be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write the Free Software Foundation,
# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import sys, os, xmpp, pipes, time

ORIGINAL_CONFIG = "/usr/share/jabber-shell/jabber-shell.conf"
GLOBAL_CONFIG = "/etc/jabber-shell.conf"
USER_CONFIG = "~/.jabber-shell.conf"
LOCAL_CONFIG = "./jabber-shell.conf"

CONFIG = dict()

def readConfig():
    """Try read config from some places"""
    def parseConfig(config):
        """Parse readed config"""
        for config_str in config.split("\n"):            
            if len(config_str.split("="))>1: 
                global CONFIG
                CONFIG[config_str.split("=")[0].strip()] = config_str.split("=")[1].strip()
    for config_path in [ORIGINAL_CONFIG, GLOBAL_CONFIG, USER_CONFIG, LOCAL_CONFIG]:
        try:
            parseConfig(open(config_path).read())
        except:
            pass

def ProcessChat(conn, mess):
    """Process chat with user"""
    global CONFIG
    def isAccess(jid):
        return jid.getStripped() in CONFIG['JID_ADMIN']
    def evalCommand():
	tmp_file = "/tmp/jabber-shell."+str(time.time())
        os.openpty()
	command = mess.getBody()+" > "+tmp_file+" 2> "+tmp_file
	print command
        os.system(command.encode('utf-8', 'replace'))
        log=open(tmp_file)
        client.send(xmpp.protocol.Message(mess.getFrom(),unicode(log.read(), "UTF-8"), "chat"))
	os.remove(tmp_file);
    if isAccess(mess.getFrom()):
        if not mess.getBody()==None:
            evalCommand()
    else:
        client.send(xmpp.protocol.Message(senderjid, "You not the administrator!", "chat"))

def StepOn(conn):
    try:
        conn.Process(1)
    except KeyboardInterrupt: return 0
    return 1

def GoOn(conn):
    while StepOn(conn): pass

readConfig()

jid       = xmpp.JID(CONFIG['JID_FROM'])
client    = xmpp.Client(jid.getDomain(), debug = False)
connected = client.connect()
auth      = client.auth(jid.getNode(), CONFIG['JID_FROM_PASS'], CONFIG['JID_CLIENT'])

client.RegisterHandler("message",ProcessChat)
client.sendInitPresence()

GoOn(client)

client.disconnect()
